import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.StringTokenizer;

public class SzoKeresoAblak extends JFrame implements ActionListener {
  private String fajlNeve="", fajlTartalma;
  private int sorokSzama=0;

  private Container cp=getContentPane();
  private JPanel pnKijelzo, pn;
  private JLabel lbFajlNeve, lbSorokSzama;
  private JTextField tfKeresendo;
  private JButton btKeres, btMegnyit;

  private JFileChooser fc;

  public SzoKeresoAblak() {
    setTitle("Szkeres");
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    setResizable(false);
    cp.setLayout(new BorderLayout());

    pn=new JPanel(new FlowLayout());
    pn.add(new JLabel("Keresend:"));
    pn.add(tfKeresendo=new JTextField(20));
    pn.add(btKeres=new JButton("Keres"));
    pn.add(btMegnyit=new JButton("Fjl megadsa"));
    cp.add(pn, "South");

    pnKijelzo=new JPanel(new GridLayout(2,1));
    pnKijelzo.add(lbFajlNeve=new JLabel("Fjl neve: "+fajlNeve));
    pnKijelzo.add(lbSorokSzama=new JLabel("Sorok szma: "+sorokSzama));
    pn=new JPanel(new FlowLayout(FlowLayout.LEFT));
    pn.add(pnKijelzo);
    cp.add(pn,"North");

    btKeres.addActionListener(this);
    btMegnyit.addActionListener(this);
    tfKeresendo.addActionListener(this);
    pack();
    show();
  }

  void megnyit(){
    fajlTartalma="";
    File f;
    fc=new JFileChooser();
    fc.setFileFilter(new TxtSzuro());

    try{
      if(fc.showOpenDialog(this)!=fc.APPROVE_OPTION)
        return;
      f=new File(fc.getSelectedFile().getAbsolutePath());
      FileReader fr=new FileReader(f);
      fajlNeve=f.getAbsolutePath().substring(f.getAbsolutePath().lastIndexOf("\\")+1);

      while(fr.ready()){
        fajlTartalma+=(char)fr.read();
      }
      lbFajlNeve.setText("Fjl neve: "+fajlNeve);
      //System.out.println(fajlTartalma);
    }catch(IOException ex){
      JOptionPane.showMessageDialog(this,"Ezt a fjlt nem lehet megnyitni!","Hiba",JOptionPane.ERROR_MESSAGE);
    }
  }

  void keres(String szo){
    sorokSzama=0;
    if(!(szo==null||szo.equals(""))){
      try {
        StringTokenizer tokSorok = new StringTokenizer(fajlTartalma, "\r\n");
        String sor;
        while(tokSorok.hasMoreTokens()){
          sor=tokSorok.nextToken();
          for(int i=0;i<sor.length()-szo.length();i++){;
            if(sor.substring(i,i+szo.length()).equals(szo)){
              sorokSzama++;
              break;
            }
          }
          //System.out.println(sorokSzama);
            lbSorokSzama.setText("Sorok szma: "+sorokSzama);
        }
      }catch (NullPointerException ex) {
        JOptionPane.showMessageDialog(this, "Elbb nyisson meg egy fjlt!",
        "Figyelmeztets",JOptionPane.WARNING_MESSAGE);
      }
    }
    else{
      JOptionPane.showMessageDialog(this, "Nem adta meg, hogy mit keres!",
        "Figyelmeztets",JOptionPane.WARNING_MESSAGE);
      sorokSzama=0;
      lbSorokSzama.setText("Sorok szma: "+sorokSzama);
    }
  }

  public void actionPerformed(ActionEvent e) {
    if(e.getSource()==btKeres||e.getSource()==tfKeresendo)
      keres(tfKeresendo.getText());

    else if(e.getSource()==btMegnyit)
      megnyit();
  }

  public static void main(String[] args) {
    new SzoKeresoAblak();
  }
}
